'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _zosjsWs = require('zosjs-ws');

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _es = require('zosjs/es');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var upColor1 = '#13b884';
var downColor1 = '#eb7676';

var ZosChart = function () {
  function ZosChart() {
    _classCallCheck(this, ZosChart);

    this.firstSymbol = undefined;
    this.secondSymbol = undefined;
    this.priceprecision = 5;
    this.periods = {
      '1': {
        title: '1Min',
        number: 60
      },
      '5': {
        title: '5Min',
        number: 300
      },
      '15': {
        title: '15Min',
        number: 900
      },
      '30': {
        title: '30Min',
        number: 1800
      },
      '60': {
        title: '1H',
        number: 3600
      },
      '240': {
        title: '4H',
        number: 14400
      },
      '1D': {
        title: '1day',
        number: 86400
      }
    };
    this.periodL = [];
    this.overrides = {
      // 'paneProperties.background': '#00081A',
      'mainSeriesProperties.showCountdown': false,
      volumePaneSize: 'medium',
      'paneProperties.legendProperties.showLegend': false,
      'paneProperties.legendProperties.showStudyArguments': true,
      'paneProperties.legendProperties.showStudyTitles': true,
      'paneProperties.legendProperties.showStudyValues': true,
      'paneProperties.legendProperties.showSeriesTitle': true,
      'paneProperties.legendProperties.showSeriesOHLC': true,
      'mainSeriesProperties.candleStyle.upColor': upColor1,
      'mainSeriesProperties.candleStyle.downColor': downColor1,
      'mainSeriesProperties.candleStyle.drawWick': true,
      'mainSeriesProperties.candleStyle.drawBorder': true,
      'mainSeriesProperties.candleStyle.borderUpColor': upColor1,
      'mainSeriesProperties.candleStyle.borderDownColor': downColor1,
      'mainSeriesProperties.candleStyle.wickUpColor': upColor1,
      'mainSeriesProperties.candleStyle.wickDownColor': downColor1,
      'mainSeriesProperties.candleStyle.barColorsOnPrevClose': false,
      'mainSeriesProperties.hollowCandleStyle.upColor': upColor1,
      'mainSeriesProperties.hollowCandleStyle.downColor': downColor1,
      'mainSeriesProperties.hollowCandleStyle.drawWick': true,
      'mainSeriesProperties.hollowCandleStyle.drawBorder': true,
      'mainSeriesProperties.hollowCandleStyle.borderUpColor': upColor1,
      'mainSeriesProperties.hollowCandleStyle.borderDownColor': downColor1,
      'mainSeriesProperties.haStyle.upColor': upColor1,
      'mainSeriesProperties.haStyle.downColor': downColor1,
      'mainSeriesProperties.haStyle.drawWick': true,
      'mainSeriesProperties.haStyle.drawBorder': true,
      'mainSeriesProperties.haStyle.borderUpColor': upColor1,
      'mainSeriesProperties.haStyle.borderDownColor': downColor1,
      'mainSeriesProperties.haStyle.barColorsOnPrevClose': false,
      'mainSeriesProperties.barStyle.upColor': upColor1,
      'mainSeriesProperties.barStyle.downColor': downColor1,
      'mainSeriesProperties.barStyle.barColorsOnPrevClose': false,
      'mainSeriesProperties.barStyle.dontDrawOpen': false,
      'mainSeriesProperties.lineStyle.linewidth': 1,
      'mainSeriesProperties.lineStyle.priceSource': 'close',
      'mainSeriesProperties.areaStyle.linewidth': 1,
      'mainSeriesProperties.areaStyle.priceSource': 'close',
      'mainSeriesProperties.style': 1
      // 'mainSeriesProperties.candleStyle.borderColor': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.hollowCandleStyle.borderColor': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.haStyle.borderColor': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.haStyle.wickColor': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.lineStyle.color': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.areaStyle.linecolor': 'rgba(52,61,88,0.2)',
      // 'mainSeriesProperties.hollowCandleStyle.wickColor': undefined,
      // 'paneProperties.crossHairProperties.color': 'rgba(52,61,88,1)',
      // 'paneProperties.horzGridProperties.color': 'rgba(52,61,88,0.2)',
      // 'paneProperties.vertGridProperties.color': 'rgba(52,61,88,0.2)',
      // 'scalesProperties.lineColor': '#343D58',
      // 'scalesProperties.textColor': '#3C434F'
    };
  }

  _createClass(ZosChart, [{
    key: 'getBuckets',
    value: function getBuckets() {
      var _this = this;

      return _zosjsWs.Apis.instance().history_api().exec('get_market_history_buckets', []).then(function (info) {
        _this.periods = {};
        _this.periodL = [];
        info.forEach(function (item) {
          if (item >= 86400) {
            var day = (item / 86400).toFixed(0);
            var add = { title: day + 'day', number: item };
            _this.periods[day + 'D'] = add;
            var _adl = { title: day + 'D', number: day + 'D' };
            _this.periodL.push(_adl);
          } else if (item >= 3600) {
            var hour = (item / 3600).toFixed(0);
            var _add = { title: hour + 'H', number: item };
            _this.periods[(item / 60).toFixed(0).toString()] = _add;
            var _adl2 = { title: hour + 'H', number: (item / 60).toFixed(0).toString() };
            _this.periodL.push(_adl2);
          } else {
            var min = (item / 60).toFixed(0);
            var _add2 = { title: min + 'Min', number: item };
            _this.periods[min.toString()] = _add2;
            var _adl3 = { title: min + 'M', number: min.toString() };
            _this.periodL.push(_adl3);
          }
        });
        var adl = { title: 'INDICATOR', number: 'INDICATOR' };
        _this.periodL.push(adl);
        return { periods: _this.periods, periodL: _this.periodL };
      });
    }
  }, {
    key: 'getPricePrecision',
    value: function getPricePrecision() {
      this.priceprecision = 5;
      if (this.firstSymbol.precision > this.secondSymbol.precision) this.priceprecision = this.firstSymbol.precision;else this.priceprecision = this.secondSymbol.precision;
      if (this.priceprecision < 5) this.priceprecision = 5;
    }
  }, {
    key: 'getMarketHistoryPrice',
    value: function getMarketHistoryPrice(v, type) {
      var price = 0;
      if (v.key.base !== this.firstSymbol.id) {
        price = v[type + '_base'] * Math.pow(10, this.firstSymbol.precision) / (v[type + '_quote'] * Math.pow(10, this.secondSymbol.precision));
      } else {
        price = v[type + '_quote'] * Math.pow(10, this.firstSymbol.precision) / (v[type + '_base'] * Math.pow(10, this.secondSymbol.precision));
      }
      price = Number(price.toFixed(this.priceprecision));
      return price;
    }
  }, {
    key: 'dataFill',
    value: function dataFill(interval, array, blockTime, limit) {
      // console.log('dataFill')
      blockTime -= 1 * interval;
      var result = [];
      var buflen = limit + 2;
      if (array.length !== 0) {
        interval = new _bignumber2.default(interval).toNumber();
        var preTime = array[0].createTime;
        array.map(function (_ref, index) {
          var createTime = _ref.createTime,
              openPrice = _ref.openPrice,
              highPrice = _ref.highPrice,
              lowPrice = _ref.lowPrice,
              closePrice = _ref.closePrice,
              volume = _ref.volume;

          if (result.length >= buflen) return;
          // console.log(index)
          if (index === 0) {
            result.push({
              createTime: createTime,
              openPrice: openPrice,
              highPrice: highPrice,
              lowPrice: lowPrice,
              closePrice: closePrice,
              volume: volume
            });
            var firstTime = createTime + interval;
            while (firstTime < blockTime + interval) {
              result.unshift({
                createTime: firstTime,
                openPrice: closePrice,
                highPrice: closePrice,
                lowPrice: closePrice,
                closePrice: closePrice,
                volume: 0
              });
              firstTime = firstTime + interval;
              if (result.length >= buflen) break;
            }
          } else {
            var currentTime = createTime;
            if (preTime - currentTime !== interval) {
              while (preTime > currentTime) {
                preTime = preTime - interval;
                if (preTime === currentTime) {
                  result.push({
                    createTime: preTime,
                    openPrice: openPrice,
                    highPrice: highPrice,
                    lowPrice: lowPrice,
                    closePrice: closePrice,
                    volume: volume
                  });
                } else {
                  result.push({
                    createTime: preTime,
                    openPrice: closePrice,
                    highPrice: closePrice,
                    lowPrice: closePrice,
                    closePrice: closePrice,
                    volume: preTime === currentTime ? volume : 0
                  });
                  if (result.length >= buflen) break;
                }
              }
            } else {
              preTime = currentTime;
              result.push({
                createTime: createTime,
                openPrice: openPrice,
                highPrice: highPrice,
                lowPrice: lowPrice,
                closePrice: closePrice,
                volume: volume
              });
            }
          }
        });
        // console.log(result.length)
        result = result.length <= buflen ? result : result.splice(0, buflen);
      } else {
        result = [{
          createTime: blockTime - interval,
          openPrice: 0,
          highPrice: 0,
          lowPrice: 0,
          closePrice: 0,
          volume: 0
        }, {
          createTime: blockTime,
          openPrice: 0,
          highPrice: 0,
          lowPrice: 0,
          closePrice: 0,
          volume: 0
        }];
      }
      return result.reverse();
    }
  }, {
    key: 'dataUpdate',
    value: function dataUpdate(interval, array, blockTime) {
      // console.log('dataUpdate')
      interval = new _bignumber2.default(interval).toNumber();
      blockTime -= 1 * interval;
      blockTime = ((blockTime / interval).toFixed(0) * interval).toFixed(0);
      var result = [];
      if (array.length !== 0) {
        array.map(function (_ref2, index) {
          var createTime = _ref2.createTime,
              openPrice = _ref2.openPrice,
              highPrice = _ref2.highPrice,
              lowPrice = _ref2.lowPrice,
              closePrice = _ref2.closePrice,
              volume = _ref2.volume;

          if (index === 0) {
            if (createTime >= blockTime) {
              result.push({
                createTime: createTime,
                openPrice: openPrice,
                highPrice: highPrice,
                lowPrice: lowPrice,
                closePrice: closePrice,
                volume: volume
              });
            } else {
              result.push({
                createTime: blockTime,
                openPrice: closePrice,
                highPrice: closePrice,
                lowPrice: closePrice,
                closePrice: closePrice,
                volume: 0
              });
            }
          }
        });
      } else {
        result = [{
          createTime: blockTime,
          openPrice: 0,
          highPrice: 0,
          lowPrice: 0,
          closePrice: 0,
          volume: 0
        }];
      }
      return result;
    }
  }, {
    key: 'getKlineData',
    value: function getKlineData(period, limit, refurbish, fromtime, blockTimeS) {
      var _this2 = this;

      // console.log('getKlineData', period)
      var blockTime = ZosChart.getTimezoneDateToUinx(blockTimeS);
      if (!this.firstSymbol.id || !this.secondSymbol.id) {
        console.error('error symbol');
        return [];
      }
      return _zosjsWs.Apis.instance().history_api().exec('get_market_klinedata', [this.firstSymbol.id, this.secondSymbol.id, period, limit, fromtime, null]).then(function (groups) {
        // console.log(groups.length, limit, refurbish)
        groups = groups.map(function (item) {
          // console.log(item.key.open, this.global.blockTime)
          return {
            createTime: ZosChart.getTimezoneDateToUinx(item.key.open),
            openPrice: _this2.getMarketHistoryPrice(item, 'open'),
            highPrice: _this2.getMarketHistoryPrice(item, 'high'),
            lowPrice: _this2.getMarketHistoryPrice(item, 'low'),
            closePrice: _this2.getMarketHistoryPrice(item, 'close'),
            volume: item.key.base !== _this2.firstSymbol.id ? item.base_volume / Math.pow(10, _this2.secondSymbol.precision) : item.quote_volume / Math.pow(10, _this2.secondSymbol.precision)
          };
        });
        if (!refurbish) groups = _this2.dataFill(period * 1000, groups, blockTime, limit);else groups = _this2.dataUpdate(period * 1000, groups, blockTime);
        // console.log(groups[0].createTime, fromtime)
        return groups;
      }).catch(function (error) {
        console.log(error);
        // this.commonUtils.showToast(error.toString())
        return [];
      });
    }
  }], [{
    key: 'getHour',
    value: function getHour(v) {
      var time1 = Number(v);
      time1 = time1 / (3600 * 1000);
      time1 = time1.toFixed(0);
      time1 = time1 * (3600 * 1000);
      return time1;
    }
  }, {
    key: 'getTimeList',
    value: function getTimeList(days) {
      var timeList = [];
      var dynParamObject = _es.ChainStore.getObject('2.0.0', true, true, true, false);
      if (!dynParamObject) {
        throw new Error('null dynParamObject');
      }
      var maxDays = 7;
      if (dynParamObject) {
        maxDays = Number(dynParamObject.get('zosparameters').get('max_market_days'));
      }
      if (maxDays > 7) maxDays = 7;
      // let timzone = new Date().getTimezoneOffset()
      var nowtime = new Date().getTime();
      var daySeconds = Number(3600 * 24 * 1000);
      var dynGlobalObject = _es.ChainStore.getObject('2.1.0', true, true, true, false);
      if (!dynGlobalObject) {
        throw new Error('null dynGlobalObject');
      }
      nowtime = ZosChart.getTimezoneDateToUinx(dynGlobalObject.get('time'));
      nowtime = Math.floor(nowtime / (3600 * 1000)) * 3600 * 1000;
      for (var day = 1; day <= maxDays; day++) {
        var add = {
          id: day,
          time: nowtime + daySeconds * day,
          timeDate: new Date(nowtime + daySeconds * day),
          symbol: day + ' ' + days
        };
        timeList.push(add);
      }
      timeList.forEach(function (item) {
        item.time = ZosChart.getHour(item.time);
        item.timeDate = new Date(item.time);
      });
      return timeList;
    }
  }, {
    key: 'getTimezoneDateToUinx',
    value: function getTimezoneDateToUinx(dateString) {
      if (dateString === undefined || dateString === null || dateString.length <= 0) return 0;
      if (dateString[dateString.length - 1] !== 'Z') dateString = dateString + 'Z';
      return new _bignumber2.default(new Date(dateString).getTime()).toNumber();
    }
  }]);

  return ZosChart;
}();

exports.default = ZosChart;